/* ftpq: action.c

Copyright (C) 2000, 2001 Mark Tranchant

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "ftpq.h"

int do_put (int sockfd) {

	int r[6];
	int datafd, port, response;
	char name[16];

	response = ftp_pasv (sockfd);
	if (response != 227)
		return NOPASV;

	if ((sscanf (strchr (hostresp, '(') + 1, "%u,%u,%u,%u,%u,%u", &r[0], &r[1], &r[2], &r[3], &r[4], &r[5])) != 6) {
		printf ("ftpq: couldn't get passive mode!\n"); 
		return NOPASV;
	}

	sprintf (name, "%d.%d.%d.%d", r[0], r[1], r[2], r[3]);
	port = (r[4] * 256) + r[5];
	datafd = get_socket_out (name, port);

	response = ftp_stor (extract_file (gv.dstpath), sockfd);	
	if (response != 125 && response != 150) {
		close (datafd); 
		return NOSTOR;
	}

	if (send_data (datafd) == -1) {
		printf ("ftpq: file transfer error!\n");
		close (datafd);
		return NOSTOR;
	}

	close (datafd);
	response = send_cmd (NULL, sockfd, RESP);
	if (category (response) == POS_COMPLETE)
		return OK;
	else
		return NOSTOR;
}

int do_get (int sockfd) {

	int datafd, response ;

	if ((datafd = get_socket_in (sockfd)) == 0) {
		printf ("ftpq: couldn't get data connection!\n");
		return NORETR;
	}

	get_data (datafd);
	close (datafd);

	response = send_cmd (NULL, sockfd, RESP);
	if (response != 226)
		return NORETR;

	return OK;
}

int do_del (int sockfd) {

	int response;

	response = ftp_dele (extract_file (gv.dstpath), sockfd);

	if (response != 250)
		return NODELE;

	return OK;
}

int do_rmdir (int sockfd) {

	ftp_rmd (extract_file (gv.dstpath), sockfd);

	return OK;
}

int do_mkdir (int sockfd) {

	ftp_mkd (extract_file (gv.dstpath), sockfd);

	return OK;
}


