/* ftpq: path.c

Copyright (C) 2000, 2001 Mark Tranchant

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "ftpq.h"


/* Given a complete path, extract_file returns a pointer to the start of */
/* the filename, or bombs out on a weird name. */

char *extract_file (char *path) {

	char *fileptr = NULL;

	fileptr = strrchr (path, (int) '/');

	if (fileptr == NULL)
		fileptr = path;
	else {
		if (strlen (fileptr) == 1) {
			printf ("ftpq: bad file specification: %s !\n", path);
			usage ();
			exit (AB_ARGERR);
		}
		else
			fileptr = &fileptr[1];
	}

	return fileptr;
}	

/* path_depth takes a pointer to a path and a depth, and returns the */
/* length of the string representing the path to that depth. */

int path_depth (char *path, int depth) {

	int ctr = 0;
	int pos = 1;

	while (ctr < depth && pos < strlen (path)) {
		if (path[pos] == '/')
			ctr++;
		pos++;
	}

	if (pos == strlen (path)) {
		if (ctr < depth - 1) 
			pos = -1;
	}
	else
		pos--;

	return pos;
}	

/* cnt_subdirs returns the number of directory levels */
/* in a file path name. */
int cnt_subdirs (char *path) {

	int ctr = 0;
	int pos = 1;

	while (pos < strlen (path)) {
		if (path[pos] == '/')
			ctr++;
		pos++;
	}

	return ctr;
}

